curl --request POST \
--url https://api.firedrill.run/v1/service-datasets \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"projectId": "<string>",
"environmentId": "<string>",
"buildId": "<string>",
"records": [
{
"namespace": "<string>",
"rowId": "<string>",
"value": {}
}
],
"initialVirtualTimeUs": 4503599627370495
}
'import requests
url = "https://api.firedrill.run/v1/service-datasets"
payload = {
"projectId": "<string>",
"environmentId": "<string>",
"buildId": "<string>",
"records": [
{
"namespace": "<string>",
"rowId": "<string>",
"value": {}
}
],
"initialVirtualTimeUs": 4503599627370495
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
projectId: '<string>',
environmentId: '<string>',
buildId: '<string>',
records: [{namespace: '<string>', rowId: '<string>', value: {}}],
initialVirtualTimeUs: 4503599627370495
})
};
fetch('https://api.firedrill.run/v1/service-datasets', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.firedrill.run/v1/service-datasets",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'projectId' => '<string>',
'environmentId' => '<string>',
'buildId' => '<string>',
'records' => [
[
'namespace' => '<string>',
'rowId' => '<string>',
'value' => [
]
]
],
'initialVirtualTimeUs' => 4503599627370495
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.firedrill.run/v1/service-datasets"
payload := strings.NewReader("{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.firedrill.run/v1/service-datasets")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.firedrill.run/v1/service-datasets")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"projectId": "<string>",
"buildId": "<string>",
"version": "<string>",
"records": 123,
"createdAt": "<string>",
"schemaVersion": "2026-10-15-dataset.1",
"initialVirtualTimeUs": 123,
"metadata": {
"schemaVersion": "2026-10-15-dataset-metadata.1",
"provenance": {
"kind": "authored",
"sensitive": true,
"description": "<string>",
"authorizedImport": true
},
"mappings": [
{
"id": "<string>",
"namespace": "<string>",
"pointer": "<string>",
"target": {
"datasetId": "<string>",
"version": "<string>",
"namespace": "<string>",
"pointer": "<string>"
},
"optional": false
}
]
},
"validation": {
"schemaVersion": "2026-10-15-dataset-validation.1",
"state": "validated",
"manifestDigest": "<string>",
"recordsDigest": "<string>",
"metadataDigest": "<string>",
"policyDigest": "<string>",
"checkedRecords": 123,
"schema": "valid",
"domain": {
"state": "satisfied",
"constraintIds": [
"<string>"
]
},
"mappings": {
"state": "satisfied",
"checks": [
{
"id": "<string>",
"datasetId": "<string>",
"version": "<string>",
"recordsDigest": "<string>"
}
]
},
"provenance": {
"state": "not_recorded",
"kind": "authored",
"sensitive": false,
"importAuthorization": "not_applicable"
},
"fidelity": "not_established",
"validatedAt": "<string>",
"digest": "<string>"
},
"validationStatus": "not_recorded"
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}Publish synthetic Tool data
Requires services:publish. Pins seed records to an exact project-owned build and optional managed starting time/provenance. Duplicate namespace/row identities are rejected. An omitted dataset is not a request for starter records.
curl --request POST \
--url https://api.firedrill.run/v1/service-datasets \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"projectId": "<string>",
"environmentId": "<string>",
"buildId": "<string>",
"records": [
{
"namespace": "<string>",
"rowId": "<string>",
"value": {}
}
],
"initialVirtualTimeUs": 4503599627370495
}
'import requests
url = "https://api.firedrill.run/v1/service-datasets"
payload = {
"projectId": "<string>",
"environmentId": "<string>",
"buildId": "<string>",
"records": [
{
"namespace": "<string>",
"rowId": "<string>",
"value": {}
}
],
"initialVirtualTimeUs": 4503599627370495
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
projectId: '<string>',
environmentId: '<string>',
buildId: '<string>',
records: [{namespace: '<string>', rowId: '<string>', value: {}}],
initialVirtualTimeUs: 4503599627370495
})
};
fetch('https://api.firedrill.run/v1/service-datasets', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.firedrill.run/v1/service-datasets",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'projectId' => '<string>',
'environmentId' => '<string>',
'buildId' => '<string>',
'records' => [
[
'namespace' => '<string>',
'rowId' => '<string>',
'value' => [
]
]
],
'initialVirtualTimeUs' => 4503599627370495
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.firedrill.run/v1/service-datasets"
payload := strings.NewReader("{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.firedrill.run/v1/service-datasets")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.firedrill.run/v1/service-datasets")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"projectId\": \"<string>\",\n \"environmentId\": \"<string>\",\n \"buildId\": \"<string>\",\n \"records\": [\n {\n \"namespace\": \"<string>\",\n \"rowId\": \"<string>\",\n \"value\": {}\n }\n ],\n \"initialVirtualTimeUs\": 4503599627370495\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"projectId": "<string>",
"buildId": "<string>",
"version": "<string>",
"records": 123,
"createdAt": "<string>",
"schemaVersion": "2026-10-15-dataset.1",
"initialVirtualTimeUs": 123,
"metadata": {
"schemaVersion": "2026-10-15-dataset-metadata.1",
"provenance": {
"kind": "authored",
"sensitive": true,
"description": "<string>",
"authorizedImport": true
},
"mappings": [
{
"id": "<string>",
"namespace": "<string>",
"pointer": "<string>",
"target": {
"datasetId": "<string>",
"version": "<string>",
"namespace": "<string>",
"pointer": "<string>"
},
"optional": false
}
]
},
"validation": {
"schemaVersion": "2026-10-15-dataset-validation.1",
"state": "validated",
"manifestDigest": "<string>",
"recordsDigest": "<string>",
"metadataDigest": "<string>",
"policyDigest": "<string>",
"checkedRecords": 123,
"schema": "valid",
"domain": {
"state": "satisfied",
"constraintIds": [
"<string>"
]
},
"mappings": {
"state": "satisfied",
"checks": [
{
"id": "<string>",
"datasetId": "<string>",
"version": "<string>",
"recordsDigest": "<string>"
}
]
},
"provenance": {
"state": "not_recorded",
"kind": "authored",
"sensitive": false,
"importAuthorization": "not_applicable"
},
"fidelity": "not_established",
"validatedAt": "<string>",
"digest": "<string>"
},
"validationStatus": "not_recorded"
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"repair": "<string>",
"requestId": "<string>",
"details": "<string>",
"validation": {
"issues": [
{
"path": [
"<string>"
],
"code": "<string>",
"message": "<string>",
"pathTruncated": true
}
],
"totalIssues": 123,
"omittedIssues": 123
}
}
}Authorizations
Opaque Firedrill interactive or scoped machine credential. The CLI handles human-approved login; CI stores its scoped credential as FIREDRILL_TOKEN. Capabilities and project/environment ownership are rechecked at use.
Headers
Save a unique stable key for this exact logical action, at most 200 characters. Reuse it with identical input after an uncertain response. A new key is new intent; it must not be used merely to recover an accepted action.
1 - 200Body
1 - 1601 - 1601 - 160100000Show child attributes
Show child attributes
0 <= x <= 9007199254740991Show child attributes
Show child attributes
Response
The retained resource or operation response.
2026-10-15-dataset.1 Show child attributes
Show child attributes
Show child attributes
Show child attributes
not_recorded, validated